Loading...
Searching...
No Matches
hack_array_iterator< T, Ref, Ptr, Raw, RawIterator >

## Detailed Description

template<class T, class Ref, class Ptr, class Raw, class RawIterator>
struct rheolef::hack_array_iterator< T, Ref, Ptr, Raw, RawIterator >

Definition at line 41 of file hack_array.h.

## Public Types

typedef hack_array_iterator< T, Ref, Ptr, Raw, RawIterator > | _self
typedef hack_array_iterator< T, T &, T *, Raw, Raw * > | _iterator
typedef std::bidirectional_iterator_tag | iterator_category
typedef T | value_type
typedef Ref | reference
typedef Ptr | pointer
typedef T::size_type | size_type
typedef std::iterator_traits< RawIterator >::difference_type | difference_type

## Public Member Functions

| hack_array_iterator ()
| hack_array_iterator (RawIterator raw_iter, size_type incr)
| hack_array_iterator (const _iterator &y)
_self & | operator++ ()
_self | operator++ (int)
pointer | operator-> () const
reference | operator* () const
reference | operator[] (size_type i) const
_self & | operator+= (size_type n)
_self & | operator-= (size_type n)
_self | operator+ (size_type n) const
_self | operator- (size_type n) const
bool | operator== (const _self &y) const
bool | operator!= (const _self &y) const

## Public Attributes

RawIterator | _raw_iter
size_type | _incr

## Member Typedef Documentation

## _self

template<class T , class Ref , class Ptr , class Raw , class RawIterator >

typedef hack_array_iterator<T, Ref, Ptr, Raw, RawIterator> _self

Definition at line 42 of file hack_array.h.

## _iterator

template<class T , class Ref , class Ptr , class Raw , class RawIterator >

typedef hack_array_iterator<T, T&, T*, Raw, Raw*> _iterator

Definition at line 43 of file hack_array.h.

## iterator_category

template<class T , class Ref , class Ptr , class Raw , class RawIterator >

typedef std::bidirectional_iterator_tag iterator_category

Definition at line 45 of file hack_array.h.

## value_type

template<class T , class Ref , class Ptr , class Raw , class RawIterator >

typedef T value_type

Definition at line 46 of file hack_array.h.

## reference

template<class T , class Ref , class Ptr , class Raw , class RawIterator >

typedef Ref reference

Definition at line 47 of file hack_array.h.

## pointer

template<class T , class Ref , class Ptr , class Raw , class RawIterator >

typedef Ptr pointer

Definition at line 48 of file hack_array.h.

## size_type

template<class T , class Ref , class Ptr , class Raw , class RawIterator >

typedef T::size_type size_type

Definition at line 49 of file hack_array.h.

## difference_type

template<class T , class Ref , class Ptr , class Raw , class RawIterator >

typedef std::iterator_traits<RawIterator>::difference_type difference_type

Definition at line 50 of file hack_array.h.

## Constructor & Destructor Documentation

## hack_array_iterator() [1/3]

template<class T , class Ref , class Ptr , class Raw , class RawIterator >

hack_array_iterator | ( |  | ) |

Definition at line 52 of file hack_array.h.

## hack_array_iterator() [2/3]

template<class T , class Ref , class Ptr , class Raw , class RawIterator >

hack_array_iterator | ( | RawIterator | raw_iter,
|  | size_type | incr
| ) |  |

Definition at line 54 of file hack_array.h.

## hack_array_iterator() [3/3]

template<class T , class Ref , class Ptr , class Raw , class RawIterator >

hack_array_iterator | ( | const _iterator & | y | ) |

Definition at line 56 of file hack_array.h.

## Member Function Documentation

## operator++() [1/2]

template<class T , class Ref , class Ptr , class Raw , class RawIterator >

_self & operator++ | ( |  | ) |

Definition at line 58 of file hack_array.h.

## operator++() [2/2]

template<class T , class Ref , class Ptr , class Raw , class RawIterator >

_self operator++ | ( | int |  | ) |

Definition at line 59 of file hack_array.h.

## operator->()

template<class T , class Ref , class Ptr , class Raw , class RawIterator >

pointer operator-> | ( |  | ) | const

Definition at line 60 of file hack_array.h.

## operator*()

template<class T , class Ref , class Ptr , class Raw , class RawIterator >

reference operator* | ( |  | ) | const

Definition at line 61 of file hack_array.h.

## operator[]()

template<class T , class Ref , class Ptr , class Raw , class RawIterator >

reference operator[] | ( | size_type | i | ) | const

Definition at line 62 of file hack_array.h.

## operator+=()

template<class T , class Ref , class Ptr , class Raw , class RawIterator >

_self & operator+= | ( | size_type | n | ) |

Definition at line 63 of file hack_array.h.

## operator-=()

template<class T , class Ref , class Ptr , class Raw , class RawIterator >

_self & operator-= | ( | size_type | n | ) |

Definition at line 64 of file hack_array.h.

## operator+()

template<class T , class Ref , class Ptr , class Raw , class RawIterator >

_self operator+ | ( | size_type | n | ) | const

Definition at line 65 of file hack_array.h.

## operator-()

template<class T , class Ref , class Ptr , class Raw , class RawIterator >

_self operator- | ( | size_type | n | ) | const

Definition at line 66 of file hack_array.h.

## operator==()

template<class T , class Ref , class Ptr , class Raw , class RawIterator >

bool operator== | ( | const _self & | y | ) | const

Definition at line 67 of file hack_array.h.

## operator!=()

template<class T , class Ref , class Ptr , class Raw , class RawIterator >

bool operator!= | ( | const _self & | y | ) | const

Definition at line 68 of file hack_array.h.

## Member Data Documentation

## _raw_iter

template<class T , class Ref , class Ptr , class Raw , class RawIterator >

RawIterator _raw_iter

Definition at line 71 of file hack_array.h.

## _incr

template<class T , class Ref , class Ptr , class Raw , class RawIterator >

size_type _incr

Definition at line 72 of file hack_array.h.

The documentation for this struct was generated from the following file:

- /build/rheolef-Hrneba/rheolef-7.2/main/lib/hack_array.h